/*
 * pnglib_exports.h - internal header with definitions of all exported functions
 *
 * Copyright (C) 2018 Thorsten Otto
 *
 * This code is released under the libpng license.
 * For conditions of distribution and use, see the disclaimer
 * and license in png.h
 */

#ifndef LIBFUNC
# error "LIBFUNC must be defined before including this file"
#endif
#ifndef LIBFUNC2
#define LIBFUNC2(_fn, name, _nargs) LIBFUNC(_fn, name, _nargs)
#endif

#if defined(PNG_FLOATING_ARITHMETIC_SUPPORTED) || defined(PNG_FLOATING_POINT_SUPPORTED)
#define LIBFUNC_FP(_fn, name, _nargs) LIBFUNC(_fn, name, _nargs)
#define LIBFUNC_FP2(_fn, name, _nargs) LIBFUNC2(_fn, name, _nargs)
#else
#define LIBFUNC_FP(_fn, name, _nargs) NOFUNC
#define LIBFUNC_FP2(_fn, name, _nargs) NOFUNC
#endif
#ifdef PNG_FIXED_POINT_SUPPORTED
#define LIBFUNC_FIXED(_fn, name, _nargs) LIBFUNC(_fn, name, _nargs)
#define LIBFUNC_FIXED2(_fn, name, _nargs) LIBFUNC2(_fn, name, _nargs)
#else
#define LIBFUNC_FIXED(_fn, name, _nargs) NOFUNC
#define LIBFUNC_FIXED2(_fn, name, _nargs) NOFUNC
#endif


	LIBFUNC(0, pnglib_slb_control, 2)
	LIBFUNC(1, png_access_version_number, 0)
	LIBFUNC(2, png_set_sig_bytes, 2)
	LIBFUNC(3, png_sig_cmp, 3)
	LIBFUNC(4, png_create_read_struct, 4)
	LIBFUNC(5, png_create_write_struct, 4)
	LIBFUNC(6, png_get_compression_buffer_size, 0)
	LIBFUNC(7, png_set_compression_buffer_size, 0)
#ifdef PNG_SETJMP_SUPPORTED
	LIBFUNC(8, png_set_longjmp_fn, 2)
#else
	NOFUNC
#endif
	LIBFUNC(9, png_longjmp, 0)
#ifdef PNG_READ_SUPPORTED
	LIBFUNC(10, png_reset_zstream, 1)
#else
	NOFUNC
#endif
#ifdef PNG_USER_MEM_SUPPORTED
	LIBFUNC(11, png_create_read_struct_2, 7)
	LIBFUNC(12, png_create_write_struct_2, 7)
#else
	NOFUNC
	NOFUNC
#endif
	LIBFUNC(13, png_write_sig, 1)
	LIBFUNC(14, png_write_chunk, 4)
	LIBFUNC(15, png_write_chunk_start, 3)
	LIBFUNC(16, png_write_chunk_data, 3)
	LIBFUNC(17, png_write_chunk_end, 1)
	LIBFUNC(18, png_create_info_struct, 1)
	LIBFUNC(19, png_info_init_3, 2)
	LIBFUNC(20, png_write_info_before_PLTE, 2)
	LIBFUNC(21, png_write_info, 2)
#ifdef PNG_SEQUENTIAL_READ_SUPPORTED
	LIBFUNC(22, png_read_info, 2)
#else
	NOFUNC
#endif
#ifdef PNG_TIME_RFC1123_SUPPORTED
	LIBFUNC(23, png_convert_to_rfc1123, 2)
#else
	NOFUNC
#endif
#ifdef PNG_CONVERT_tIME_SUPPORTED
	LIBFUNC(24, png_convert_from_struct_tm, 2)
	LIBFUNC(25, png_convert_from_time_t, 2)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_READ_EXPAND_SUPPORTED
	LIBFUNC(26, png_set_expand, 1)
	LIBFUNC(27, png_set_expand_gray_1_2_4_to_8, 1)
	LIBFUNC(28, png_set_palette_to_rgb, 1)
	LIBFUNC(29, png_set_tRNS_to_alpha, 1)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#if defined(PNG_READ_BGR_SUPPORTED) || defined(PNG_WRITE_BGR_SUPPORTED)
	LIBFUNC(30, png_set_bgr, 1)
#else
	NOFUNC
#endif
#ifdef PNG_READ_GRAY_TO_RGB_SUPPORTED
	LIBFUNC(31, png_set_gray_to_rgb, 1)
#else
	NOFUNC
#endif
#ifdef PNG_READ_RGB_TO_GRAY_SUPPORTED
	LIBFUNC_FP(32, png_set_rgb_to_gray, 6)
	LIBFUNC_FIXED(33, png_set_rgb_to_gray_fixed, 4)
	LIBFUNC(34, png_get_rgb_to_gray_status, 1)
#else
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_BUILD_GRAYSCALE_PALETTE_SUPPORTED
	LIBFUNC(35, png_build_grayscale_palette, 2)
#else
	NOFUNC
#endif
#ifdef PNG_READ_STRIP_ALPHA_SUPPORTED
	LIBFUNC(36, png_set_strip_alpha, 1)
#else
	NOFUNC
#endif
#if defined(PNG_READ_SWAP_ALPHA_SUPPORTED) || defined(PNG_WRITE_SWAP_ALPHA_SUPPORTED)
	LIBFUNC(37, png_set_swap_alpha, 1)
#else
	NOFUNC
#endif
#if defined(PNG_READ_INVERT_ALPHA_SUPPORTED) || defined(PNG_WRITE_INVERT_ALPHA_SUPPORTED)
	LIBFUNC(38, png_set_invert_alpha, 1)
#else
	NOFUNC
#endif
#if defined(PNG_READ_FILLER_SUPPORTED) || defined(PNG_WRITE_FILLER_SUPPORTED)
	LIBFUNC(39, png_set_filler, 3)
	LIBFUNC(40, png_set_add_alpha, 3)
#else
	NOFUNC
	NOFUNC
#endif
#if defined(PNG_READ_SWAP_SUPPORTED) || defined(PNG_WRITE_SWAP_SUPPORTED)
	LIBFUNC(41, png_set_swap, 1)
#else
	NOFUNC
#endif
#if defined(PNG_READ_PACK_SUPPORTED) || defined(PNG_WRITE_PACK_SUPPORTED)
	LIBFUNC(42, png_set_packing, 1)
#else
	NOFUNC
#endif
#if defined(PNG_READ_PACKSWAP_SUPPORTED) || defined(PNG_WRITE_PACKSWAP_SUPPORTED)
	LIBFUNC(43, png_set_packswap, 1)
#else
	NOFUNC
#endif
#if defined(PNG_READ_SHIFT_SUPPORTED) || defined(PNG_WRITE_SHIFT_SUPPORTED)
	LIBFUNC(44, png_set_shift, 2)
#else
	NOFUNC
#endif
#if defined(PNG_READ_INTERLACING_SUPPORTED) || defined(PNG_WRITE_INTERLACING_SUPPORTED)
	LIBFUNC(45, png_set_interlace_handling, 1)
#else
	NOFUNC
#endif
#if defined(PNG_READ_INVERT_SUPPORTED) || defined(PNG_WRITE_INVERT_SUPPORTED)
	LIBFUNC(46, png_set_invert_mono, 1)
#else
	NOFUNC
#endif
#ifdef PNG_READ_BACKGROUND_SUPPORTED
	LIBFUNC_FP(47, png_set_background, 6)
#else
	NOFUNC
#endif
#if defined(PNG_READ_STRIP_16_TO_8_SUPPORTED) || defined(PNG_READ_16_TO_8_SUPPORTED)
	LIBFUNC(48, png_set_strip_16, 1)
#else
	NOFUNC
#endif
#ifdef PNG_READ_QUANTIZE_SUPPORTED
	LIBFUNC(49, png_set_quantize, 6)
#else
	NOFUNC
#endif
#ifdef PNG_READ_GAMMA_SUPPORTED
	LIBFUNC_FP(50, png_set_gamma, 5)
#else
	NOFUNC
#endif
#ifdef PNG_WRITE_FLUSH_SUPPORTED
	LIBFUNC(51, png_set_flush, 2)
	LIBFUNC(52, png_write_flush, 1)
#else
	NOFUNC
	NOFUNC
#endif
	LIBFUNC(53, png_start_read_image, 1)
	LIBFUNC(54, png_read_update_info, 2)
#ifdef PNG_SEQUENTIAL_READ_SUPPORTED
	LIBFUNC(55, png_read_rows, 4)
	LIBFUNC(56, png_read_row, 3)
	LIBFUNC(57, png_read_image, 2)
#else
	NOFUNC
	NOFUNC
	NOFUNC
#endif
	LIBFUNC(58, png_write_row, 2)
	LIBFUNC(59, png_write_rows, 3)
	LIBFUNC(60, png_write_image, 2)
	LIBFUNC(61, png_write_end, 2)
#ifdef PNG_SEQUENTIAL_READ_SUPPORTED
	LIBFUNC(62, png_read_end, 2)
#else
	NOFUNC
#endif
	LIBFUNC(63, png_destroy_info_struct, 2)
	LIBFUNC(64, png_destroy_read_struct, 3)
	LIBFUNC(65, png_destroy_write_struct, 2)
	LIBFUNC(66, png_set_crc_action, 3)
#ifdef PNG_WRITE_SUPPORTED
	LIBFUNC(67, png_set_filter, 3)
#else
	NOFUNC
#endif
#if defined(PNG_WRITE_SUPPORTED) && defined(PNG_WRITE_WEIGHTED_FILTER_SUPPORTED)
	LIBFUNC_FP(68, png_set_filter_heuristics, 5)
#else
	NOFUNC
#endif
#if defined(PNG_WRITE_SUPPORTED) && defined(PNG_WRITE_CUSTOMIZE_COMPRESSION_SUPPORTED)
	LIBFUNC(69, png_set_compression_level, 2)
	LIBFUNC(70, png_set_compression_mem_level, 2)
	LIBFUNC(71, png_set_compression_strategy, 2)
	LIBFUNC(72, png_set_compression_window_bits, 2)
	LIBFUNC(73, png_set_compression_method, 2)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_STDIO_SUPPORTED
	LIBFUNC(74, png_init_io, 2)
#else
	NOFUNC
#endif
	LIBFUNC(75, png_set_error_fn, 4)
	LIBFUNC(76, png_get_error_ptr, 1)
	LIBFUNC(77, png_set_write_fn, 4)
	LIBFUNC(78, png_set_read_fn, 4)
	LIBFUNC(79, png_get_io_ptr, 1)
	LIBFUNC(80, png_set_read_status_fn, 2)
	LIBFUNC(81, png_set_write_status_fn, 2)
#ifdef PNG_USER_MEM_SUPPORTED
	LIBFUNC(82, png_set_mem_fn, 4)
	LIBFUNC(83, png_get_mem_ptr, 1)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_READ_USER_TRANSFORM_SUPPORTED
	LIBFUNC(84, png_set_read_user_transform_fn, 2)
#else
	NOFUNC
#endif
#ifdef PNG_WRITE_USER_TRANSFORM_SUPPORTED
	LIBFUNC(85, png_set_write_user_transform_fn, 2)
#else
	NOFUNC
#endif
#ifdef PNG_USER_TRANSFORM_PTR_SUPPORTED
	LIBFUNC(86, png_set_user_transform_info, 4)
	LIBFUNC(87, png_get_user_transform_ptr, 1)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_READ_USER_CHUNKS_SUPPORTED
	LIBFUNC(88, png_set_read_user_chunk_fn, 3)
#else
	NOFUNC
#endif
#ifdef PNG_USER_CHUNKS_SUPPORTED
	LIBFUNC(89, png_get_user_chunk_ptr, 1)
#else
	NOFUNC
#endif
#ifdef PNG_PROGRESSIVE_READ_SUPPORTED
	LIBFUNC(90, png_set_progressive_read_fn, 5)
	LIBFUNC(91, png_get_progressive_ptr, 1)
	LIBFUNC(92, png_process_data, 4)
	LIBFUNC(93, png_progressive_combine_row, 3)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
	LIBFUNC(94, png_malloc, 2)
	LIBFUNC(95, png_calloc, 2)
	LIBFUNC(96, png_malloc_warn, 2)
	LIBFUNC(97, png_free, 2)
	LIBFUNC(98, png_free_data, 4)
	LIBFUNC(99, png_data_freer, 4)
#ifdef PNG_USER_MEM_SUPPORTED
	LIBFUNC(100, png_malloc_default, 2)
	LIBFUNC(101, png_free_default, 2)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_ERROR_TEXT_SUPPORTED
	LIBFUNC(102, png_error, 2)
	LIBFUNC(103, png_chunk_error, 2)
#else
	NOFUNC
	NOFUNC
#endif
#ifndef PNG_ERROR_TEXT_SUPPORTED
	LIBFUNC(104, png_err, 1)
#else
	NOFUNC
#endif
#ifdef PNG_WARNINGS_SUPPORTED
	LIBFUNC(105, png_warning, 2)
	LIBFUNC(106, png_chunk_warning, 2)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_BENIGN_ERRORS_SUPPORTED
	LIBFUNC(107, png_benign_error, 2)
#else
	NOFUNC
#endif
#if defined(PNG_BENIGN_ERRORS_SUPPORTED) && defined(PNG_READ_SUPPORTED)
	LIBFUNC(108, png_chunk_benign_error, 2)
#else
	NOFUNC
#endif
#ifdef PNG_BENIGN_ERRORS_SUPPORTED
	LIBFUNC(109, png_set_benign_errors, 2)
#else
	NOFUNC
#endif
	LIBFUNC(110, png_get_valid, 3)
	LIBFUNC(111, png_get_rowbytes, 2)
#ifdef PNG_INFO_IMAGE_SUPPORTED
	LIBFUNC(112, png_get_rows, 2)
	LIBFUNC(113, png_set_rows, 3)
#else
	NOFUNC
	NOFUNC
#endif
	LIBFUNC(114, png_get_channels, 2)
#ifdef PNG_EASY_ACCESS_SUPPORTED
	LIBFUNC(115, png_get_image_width, 2)
	LIBFUNC(116, png_get_image_height, 2)
	LIBFUNC(117, png_get_bit_depth, 2)
	LIBFUNC(118, png_get_color_type, 2)
	LIBFUNC(119, png_get_filter_type, 2)
	LIBFUNC(120, png_get_interlace_type, 2)
	LIBFUNC(121, png_get_compression_type, 2)
	LIBFUNC(122, png_get_pixels_per_meter, 2)
	LIBFUNC(123, png_get_x_pixels_per_meter, 2)
	LIBFUNC(124, png_get_y_pixels_per_meter, 2)
	LIBFUNC_FP(125, png_get_pixel_aspect_ratio, 2)
	LIBFUNC(126, png_get_x_offset_pixels, 2)
	LIBFUNC(127, png_get_y_offset_pixels, 2)
	LIBFUNC2(128, png_get_x_offset_microns, 2)
	LIBFUNC2(129, png_get_y_offset_microns, 2)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_READ_SUPPORTED
	LIBFUNC2(130, png_get_signature, 2)
#else
	NOFUNC
#endif
#ifdef PNG_bKGD_SUPPORTED
	LIBFUNC2(131, png_get_bKGD, 3)
	LIBFUNC2(132, png_set_bKGD, 3)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_cHRM_SUPPORTED
	LIBFUNC_FP2(133, png_get_cHRM, 10)
	LIBFUNC_FIXED2(134, png_get_cHRM_fixed, 10)
	LIBFUNC_FP2(135, png_set_cHRM, 18)
	LIBFUNC_FIXED2(136, png_set_cHRM_fixed, 18)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_gAMA_SUPPORTED
	LIBFUNC_FP2(137, png_get_gAMA, 3)
	LIBFUNC_FIXED2(138, png_get_gAMA_fixed, 3)
	LIBFUNC_FP2(139, png_set_gAMA, 4)
	LIBFUNC_FIXED2(140, png_set_gAMA_fixed, 3)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_hIST_SUPPORTED
	LIBFUNC2(141, png_get_hIST, 3)
	LIBFUNC2(142, png_set_hIST, 3)
#else
	NOFUNC
	NOFUNC
#endif
	LIBFUNC2(143, png_get_IHDR, 9)
	LIBFUNC2(144, png_set_IHDR, 9)
#ifdef PNG_oFFs_SUPPORTED
	LIBFUNC2(145, png_get_oFFs, 5)
	LIBFUNC2(146, png_set_oFFs, 5)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_pCAL_SUPPORTED
	LIBFUNC2(147, png_get_pCAL, 9)
	LIBFUNC2(148, png_set_pCAL, 9)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_pHYs_SUPPORTED
	LIBFUNC2(149, png_get_pHYs, 5)
	LIBFUNC2(150, png_set_pHYs, 5)
#else
	NOFUNC
	NOFUNC
#endif
	LIBFUNC2(151, png_get_PLTE, 4)
	LIBFUNC2(152, png_set_PLTE, 4)
#ifdef PNG_sBIT_SUPPORTED
	LIBFUNC2(153, png_get_sBIT, 3)
	LIBFUNC2(154, png_set_sBIT, 3)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_sRGB_SUPPORTED
	LIBFUNC2(155, png_get_sRGB, 3)
	LIBFUNC2(156, png_set_sRGB, 3)
	LIBFUNC2(157, png_set_sRGB_gAMA_and_cHRM, 3)
#else
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_iCCP_SUPPORTED
	LIBFUNC2(158, png_get_iCCP, 6)
	LIBFUNC2(159, png_set_iCCP, 6)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_iCCP_SUPPORTED
	LIBFUNC2(160, png_get_sPLT, 3)
	LIBFUNC2(161, png_set_sPLT, 3)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_TEXT_SUPPORTED
	LIBFUNC2(162, png_get_text, 4)
	LIBFUNC2(163, png_set_text, 4)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_tIME_SUPPORTED
	LIBFUNC2(164, png_get_tIME, 3)
	LIBFUNC2(165, png_set_tIME, 3)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_tRNS_SUPPORTED
	LIBFUNC2(166, png_get_tRNS, 5)
	LIBFUNC2(167, png_set_tRNS, 5)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_sCAL_SUPPORTED
	LIBFUNC_FP2(168, png_get_sCAL, 5)
	LIBFUNC2(169, png_get_sCAL_s, 5)
	LIBFUNC_FP2(170, png_set_sCAL, 7)
	LIBFUNC2(171, png_set_sCAL_s, 5)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#if defined(PNG_SET_UNKNOWN_CHUNKS_SUPPORTED) && defined(PNG_HANDLE_AS_UNKNOWN_SUPPORTED)
	LIBFUNC2(172, png_set_keep_unknown_chunks, 4)
#else
	NOFUNC
#endif
#ifdef PNG_SET_UNKNOWN_CHUNKS_SUPPORTED
	LIBFUNC2(173, png_handle_as_unknown, 2)
#else
	NOFUNC
#endif
#ifdef PNG_STORE_UNKNOWN_CHUNKS_SUPPORTED
	LIBFUNC2(174, png_set_unknown_chunks, 4)
	LIBFUNC2(175, png_set_unknown_chunk_location, 4)
	LIBFUNC2(176, png_get_unknown_chunks, 3)
#else
	NOFUNC
	NOFUNC
	NOFUNC
#endif
	LIBFUNC2(177, png_set_invalid, 3)
#if defined(PNG_INFO_IMAGE_SUPPORTED) && defined(PNG_SEQUENTIAL_READ_SUPPORTED)
	LIBFUNC2(178, png_read_png, 4)
#else
	NOFUNC
#endif
#if defined(PNG_INFO_IMAGE_SUPPORTED) && defined(PNG_WRITE_SUPPORTED)
	LIBFUNC2(179, png_write_png, 4)
#else
	NOFUNC
#endif
	LIBFUNC2(180, png_get_copyright, 1)
	LIBFUNC2(181, png_get_header_ver, 1)
	LIBFUNC2(182, png_get_header_version, 1)
	LIBFUNC2(183, png_get_libpng_ver, 2)
#ifdef PNG_MNG_FEATURES_SUPPORTED
	LIBFUNC2(184, png_permit_mng_features, 2)
#else
	NOFUNC
#endif
#ifdef PNG_ERROR_NUMBERS_SUPPORTED
	LIBFUNC2(185, png_set_strip_error_numbers, 2)
#else
	NOFUNC
#endif
#ifdef PNG_SET_USER_LIMITS_SUPPORTED
	LIBFUNC2(186, png_set_user_limits, 3)
	LIBFUNC2(187, png_get_user_width_max, 1)
	LIBFUNC2(188, png_get_user_height_max, 1)
	LIBFUNC2(189, png_set_chunk_cache_max, 2)
	LIBFUNC2(190, png_get_chunk_cache_max, 1)
	LIBFUNC2(191, png_set_chunk_malloc_max, 2)
	LIBFUNC2(192, png_get_chunk_malloc_max, 1)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#if defined(PNG_INCH_CONVERSIONS_SUPPORTED)
	LIBFUNC2(193, png_get_pixels_per_inch, 2)
	LIBFUNC2(194, png_get_x_pixels_per_inch, 2)
	LIBFUNC2(195, png_get_y_pixels_per_inch, 2)
	LIBFUNC_FP2(196, png_get_x_offset_inches, 2)
	LIBFUNC_FP2(197, png_get_y_offset_inches, 2)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#if defined(PNG_INCH_CONVERSIONS_SUPPORTED) && defined(PNG_pHYs_SUPPORTED)
	LIBFUNC2(198, png_get_pHYs_dpi, 5)
#else
	NOFUNC
#endif
	LIBFUNC2(199, png_get_io_state, 0)
#if PNG_LIBPNG_VER < 10600
	LIBFUNC2(200, png_get_io_chunk_name, 1)
#else
	NOFUNC
#endif
#ifdef PNG_READ_INT_FUNCTIONS_SUPPORTED
	LIBFUNC2(201, png_get_uint_32, 1)
	LIBFUNC2(202, png_get_uint_16, 1)
	LIBFUNC2(203, png_get_int_32, 1)
#else
	NOFUNC
	NOFUNC
	NOFUNC
#endif
	LIBFUNC2(204, png_get_uint_31, 1)
#ifdef PNG_WRITE_INT_FUNCTIONS_SUPPORTED
	LIBFUNC2(205, png_save_uint_32, 2)
#else
	NOFUNC
#endif
#ifdef PNG_SAVE_INT_32_SUPPORTED
	LIBFUNC2(206, png_save_int_32, 2)
#else
	NOFUNC
#endif
#ifdef PNG_WRITE_INT_FUNCTIONS_SUPPORTED
	LIBFUNC2(207, png_save_uint_16, 2)
#else
	NOFUNC
#endif
#ifdef PNG_READ_GAMMA_SUPPORTED
	LIBFUNC_FIXED2(208, png_set_gamma_fixed, 3)
#else
	NOFUNC
#endif
#if defined(PNG_WRITE_SUPPORTED) && defined(PNG_WRITE_WEIGHTED_FILTER_SUPPORTED)
	LIBFUNC_FIXED2(209, png_set_filter_heuristics_fixed, 5)
#else
	NOFUNC
#endif
#ifdef PNG_EASY_ACCESS_SUPPORTED
	LIBFUNC_FIXED2(210, png_get_pixel_aspect_ratio_fixed, 2)
#else
	NOFUNC
#endif
#if defined(PNG_INCH_CONVERSIONS_SUPPORTED)
	LIBFUNC_FIXED2(211, png_get_x_offset_inches_fixed, 2)
	LIBFUNC_FIXED2(212, png_get_y_offset_inches_fixed, 2)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_sCAL_SUPPORTED
	LIBFUNC_FIXED2(213, png_set_sCAL_fixed, 5)
#else
	NOFUNC
#endif
#if defined(PNG_sCAL_SUPPORTED) && (defined(PNG_FLOATING_ARITHMETIC_SUPPORTED) || defined(PNG_FLOATING_POINT_SUPPORTED))
	LIBFUNC_FIXED2(214, png_get_sCAL_fixed, 5)
#else
	NOFUNC
#endif
#ifdef PNG_READ_BACKGROUND_SUPPORTED
	LIBFUNC_FIXED2(215, png_set_background_fixed, 5)
#else
	NOFUNC
#endif
	LIBFUNC2(216, png_get_io_chunk_type, 1)
#ifdef PNG_USER_TRANSFORM_INFO_SUPPORTED
	LIBFUNC2(217, png_get_current_row_number, 1)
	LIBFUNC2(218, png_get_current_pass_number, 1)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_PROGRESSIVE_READ_SUPPORTED
	LIBFUNC2(219, png_process_data_pause, 2)
	LIBFUNC2(220, png_process_data_skip, 1)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_READ_EXPAND_16_SUPPORTED
	LIBFUNC2(221, png_set_expand_16, 1)
#else
	NOFUNC
#endif
#if defined(PNG_WRITE_SUPPORTED) && defined(PNG_WRITE_CUSTOMIZE_ZTXT_COMPRESSION_SUPPORTED)
	LIBFUNC2(222, png_set_text_compression_level, 2)
	LIBFUNC2(223, png_set_text_compression_mem_level, 2)
	LIBFUNC2(224, png_set_text_compression_strategy, 2)
	LIBFUNC2(225, png_set_text_compression_window_bits, 2)
	LIBFUNC2(226, png_set_text_compression_method, 2)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_READ_ALPHA_MODE_SUPPORTED
	LIBFUNC_FP2(227, png_set_alpha_mode, 4)
	LIBFUNC_FIXED2(228, png_set_alpha_mode_fixed, 3)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_READ_SCALE_16_TO_8_SUPPORTED
	LIBFUNC2(229, png_set_scale_16, 1)
#else
	NOFUNC
#endif
#ifdef PNG_cHRM_SUPPORTED
	LIBFUNC_FP2(230, png_get_cHRM_XYZ, 11)
	LIBFUNC_FIXED2(231, png_get_cHRM_XYZ_fixed, 11)
	LIBFUNC_FP2(232, png_set_cHRM_XYZ, 20)
	LIBFUNC_FIXED2(233, png_set_cHRM_XYZ_fixed, 20)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#if defined(PNG_SIMPLIFIED_READ_SUPPORTED) && defined(PNG_STDIO_SUPPORTED)
	LIBFUNC2(234, png_image_begin_read_from_file, 2)
	LIBFUNC2(235, png_image_begin_read_from_stdio, 2)
#else
	NOFUNC
	NOFUNC
#endif
#if defined(PNG_SIMPLIFIED_READ_SUPPORTED)
	LIBFUNC2(236, png_image_begin_read_from_memory, 3)
	LIBFUNC2(237, png_image_finish_read, 5)
	LIBFUNC2(238, png_image_free, 1)
#else
	NOFUNC
	NOFUNC
	NOFUNC
#endif
#if defined(PNG_SIMPLIFIED_WRITE_SUPPORTED) && defined(PNG_SIMPLIFIED_WRITE_STDIO_SUPPORTED)
	LIBFUNC2(239, png_image_write_to_file, 6)
	LIBFUNC2(240, png_image_write_to_stdio, 6)
#else
	NOFUNC
	NOFUNC
#endif
#ifdef PNG_TIME_RFC1123_SUPPORTED
	LIBFUNC2(241, png_convert_to_rfc1123_buffer, 2)
#else
	NOFUNC
#endif
#ifdef PNG_CHECK_FOR_INVALID_INDEX_SUPPORTED
	LIBFUNC2(242, png_set_check_for_invalid_index, 2)
#else
	NOFUNC
#endif
#if defined(PNG_CHECK_FOR_INVALID_INDEX_SUPPORTED) && defined(PNG_GET_PALETTE_MAX_SUPPORTED)
	LIBFUNC2(243, png_get_palette_max, 2)
#else
	NOFUNC
#endif
#ifdef PNG_SET_OPTION_SUPPORTED
	LIBFUNC2(244, png_set_option, 3)
#else
	NOFUNC
#endif
#if defined(PNG_SIMPLIFIED_WRITE_SUPPORTED)
	LIBFUNC2(245, png_image_write_to_memory, 7)
#else
	NOFUNC
#endif
#ifdef PNG_eXIf_SUPPORTED
	LIBFUNC2(246, png_get_eXIf, 3)
	LIBFUNC2(247, png_set_eXIf, 3)
	LIBFUNC2(248, png_get_eXIf_1, 4)
	LIBFUNC2(249, png_set_eXIf_1, 4)
#else
	NOFUNC
	NOFUNC
	NOFUNC
	NOFUNC
#endif

#undef LIBFUNC
#undef LIBFUNC2
#undef NOFUNC
