/*
 * pnglib_imp_close.c - loader for library
 *
 * Copyright (C) 2018 Thorsten Otto
 *
 * This code is released under the libpng license.
 * For conditions of distribution and use, see the disclaimer
 * and license in png.h
 */
#include "slb/png.h"
#include <stdio.h>
#include <mint/mintbind.h>
#include <slb/zlib.h>
#include "libstrct.h"
#include "slbload.h"
#include "pcmath.h"

struct _pnglibslb_funcs pnglibslb_funcs;


static long _CDECL slb_unloaded(SLB_HANDLE slb, long fn, short nwords, ...)
{
	(void)slb;
	(void)fn;
	(void)nwords;
	(void) Cconws(SHAREDLIB " was already unloaded\r\n");
	Pterm(1);
	return -32;
}


void slb_pnglib_close(void)
{
	SLB *pnglib = slb_pnglib_get();

	if (!pnglib)
		return;
	if (pnglib->handle)
	{
		slb_unload(pnglib->handle);
		pnglib->handle = 0;
	}
	pnglib->exec = slb_unloaded;
	if (pnglibslb_funcs.pnglib_zlib_opened_here)
	{
		slb_zlib_close();
		pnglibslb_funcs.pnglib_zlib_opened_here = 0;
		pnglibslb_funcs.zlib = NULL;
	}
}
